%global momorel 3
%global md5sum_src0 b7ae1f652b071862ae4c90b72d549627

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 3.1.0
Release: %{momorel}m%{?dist}
Group:   Development/Libraries
License: GPL
URL:     http://www.cl.cam.ac.uk/Research/SRG/netos/xen/index.html
%NoSource 0 http://bits.xensource.com/oss-xen/release/%{version}/src.tgz/xen-%{version}-src.tgz %{md5sum_src0}
Source2: %{name}.modules
Source3: %{name}.sysconfig
Source4: %{name}.logrotate
Patch1: xen-initscript.patch
Patch3: xen-compile-fixes.patch
Patch6: xen-net-bridge.patch
Patch13: xen-dumpdir.patch
Patch18: xen-block-readonly.patch
Patch19: xen-start-fail-cleanup.patch

Patch20: xen-blktap-no-aio-epoll.patch
Patch21: xen-blktap-error-returns.patch
Patch25: xen-qemu-vnc-delete.patch
Patch26: xen-hvm-save-paths.patch
Patch27: xen-console-log.patch
Patch28: xen-keyboard.patch
Patch29: xen-3.1.0-libxc-native-protocol.patch
Patch30: xen-3.1.0-dev-native-protocol.patch
Patch31: xen-tpm-functions.patch
Patch32: xen-clobber-vif-type.patch
Patch33: xen-vmxassist-irqs.patch
Patch34: xen-3.1.0-no-xenapi-docs.patch
Patch35: xen-qemu-rtl8139-checksum.patch
Patch36: xen-qemu-bootmenu.patch
Patch37: xen-baked-tmpfile.patch

# Patches to modify the default config of xend
Patch100: xen-config-dom0-minmem.patch
Patch102: xen-3.0.2-config-allow-unix-server.patch
Patch103: xen-3.0.2-config-disable-reloc.patch

Patch160: xen-pvfb-01-qemu-fv-machine.patch
Patch161: xen-pvfb-02-qemu-pv-machine.patch
Patch162: xen-pvfb-03-xenfb-remove.patch
Patch163: xen-pvfb-04-compat.patch

Patch164: xen-qemu-vnc-revert-password.patch

Patch165: xen-qemu-iohandler-delete.patch
Patch166: xen-qemu-vnc-authentication.patch
Patch167: xen-qemu-vnc-x509-certs.patch

Patch251: pygrub-manykernels.patch

# Performance fix for listing domains
Patch280: xen-xs-transactions.patch

# CVE-2007-1321
Patch600: xen-qemu-ne2000-CVE-2007-1321.patch
# CVE-2007-4993
Patch601: pygrub-dont-exec.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel python-devel ghostscript tetex-latex 
BuildRequires: ncurses-devel gtk2-devel libaio-devel
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
%ifnarch ia64
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
# for the VMX "bios" 
BuildRequires: dev86
%endif
BuildRequires: gettext
BuildRequires: gnutls-devel
BuildRequires: openssl-devel
Requires: bridge-utils
Requires: udev >= 059
Requires: python-virtinst
Requires: xen-libs = %{version}-%{release}
# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Requires: initscripts
Prereq: chkconfig
ExclusiveArch: %{ix86} x86_64 ia64

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems, together with the kernel-xen*
packages.  Information on how to use Xen can be found at the Xen
project pages.

Virtualisation can be used to run multiple versions or multiple
Linux distributions on one system, or to test untrusted applications
in a sandboxed environment.  

%package libs
Summary: Libraries for Xen tools
Group: Development/Libraries
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig

%description libs
This package contains the libraries needed to run applications to manage 
Xen virtual machines.

%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}

%description devel
This package contains what's needed to develop applications to manage Xen
virtual machines. 

%prep
%setup -q -n %{name}-%{version}-src 
%patch1 -p1 -b .init
%patch3 -p1 -b .compile
%patch6 -p1
%patch13 -p1
%patch18 -p1
%patch19 -p1

%patch20 -p1
%patch21 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1

# config patches
%patch100 -p1
%patch102 -p1
%patch103 -p1

# Switch to QEMU for paravirt VNC server
%patch160 -p1
%patch161 -p1
%patch162 -p1
%patch163 -p1
  	 
# Remove old VNC password code
%patch164 -p1
  	 
# Add new TLS code
%patch165 -p1
%patch166 -p1
%patch167 -p1

# upstream patches
%patch251 -p1

# performance patch
%patch280 -p1

# CVE patches
%patch600 -p1
%patch601 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" %{__make} XENFB_TOOLS=y XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} tools docs

%install
rm -rf %{buildroot}
make XENFB_TOOLS=y XEN_PYTHON_NATIVE_INSTALL=1 DESTDIR=%{buildroot} prefix=/usr install-tools install-docs
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/domain
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/vnet
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/xend-db/migrate
mkdir -p %{buildroot}%{_localstatedir}/lib/xenstored
mkdir -p %{buildroot}%{_localstatedir}/run/xenstored

rm -rf %{buildroot}%{_sysconfdir}/hotplug

# install all of the public headers
mkdir -p %{buildroot}%{_includedir}/xen/io %{buildroot}%{_includedir}/xen/hvm
mkdir -p %{buildroot}%{_includedir}/xen/arch-x86
install -m 644 xen/include/public/io/*.h %{buildroot}%{_includedir}/xen/io
install -m 644 xen/include/public/hvm/*.h %{buildroot}%{_includedir}/xen/hvm
install -m 644 xen/include/public/arch-x86/*.h %{buildroot}%{_includedir}/xen/arch-x86
install -m 644 xen/include/public/*.h %{buildroot}%{_includedir}/xen/
install -m 644 xen/include/public/COPYING %{buildroot}%{_includedir}/xen/

### fixing start-script dir
mv -f %{buildroot}%{_sysconfdir}/udev/xen-backend.rules %{buildroot}%{_sysconfdir}/udev/rules.d/

mkdir -p %{buildroot}%{_sysconfdir}/sysconfig/modules
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/modules/%{name}.modules
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/sysconfig/xend

mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# silly doc dir fun
rm -fr %{buildroot}/%{_datadir}/doc/xen/
rm -rf %{buildroot}%{_datadir}/doc/qemu/

# create dirs in /var/run so that selinux contexts are right (#195952)
mkdir -p %{buildroot}%{_localstatedir}/run/xend
mkdir -p %{buildroot}%{_localstatedir}/log/xen
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console
mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images

# avoid conflicting with qemu (#199759)
rm -f %{buildroot}/%{_mandir}/man*/qemu*

#find_lang xen-xm

%post
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

if [ $1 != 0 ]; then
  /sbin/service xend condrestart
fi

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%clean
rm -rf %{buildroot}

#files -f xen-xm.lang
%files
%defattr(-,root,root)
%doc COPYING README
%doc docs/pdf/
%doc docs/misc/
%{_sbindir}/*
%{_bindir}/*
%{python_sitearch}/%{name}
%{python_sitearch}/fsimage.so
%{python_sitearch}/grub
%{_libdir}/%{name}
%{_mandir}/man?/*.?.*
%dir /usr/lib/xen
%ifnarch ia64
%dir /usr/lib/xen/boot
/usr/lib/xen/boot/hvmloader
%endif
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*.dtd
%dir %{_datadir}/%{name}/qemu
%dir %{_datadir}/%{name}/qemu/keymaps
%{_datadir}/%{name}/qemu/keymaps/*
%dir %{_localstatedir}/lib/%{name}
%{_localstatedir}/lib/%{name}/*
%{_initscriptdir}/*
%{_sysconfdir}/udev/rules.d/*
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/*
%config(noreplace) %{_sysconfdir}/sysconfig/xend
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%config(noreplace) %{_sysconfdir}/logrotate.d/xen
%attr(0755,root,root) %{_sysconfdir}/sysconfig/modules/%{name}.modules
%dir %{_localstatedir}/lib/xenstored
%dir %{_localstatedir}/run/xenstored
%dir %attr(0700,root,root) %{_localstatedir}/run/xend
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/fs/*

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%dir %{_includedir}/xen
%{_includedir}/xen/*
%{_libdir}/*.so
%{_libdir}/*.a

%changelog
* Tue Oct 30 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.1.0-3m)
- cleanup spec
- fix CVE-2007-1321, CVE-2007-3919, CVE-2007-4993
-- import Fedora Patches(3.1.0-13)
 
* Mon Jul 23 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (3.1.0-2m)
- add Requires: initscripts
- fix %%post PATH to service
 
* Tue Jun 19 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.1.0-1m)
- up to 3.1.0
- be synchronized with fedora
- modify initscripts

* Fri Jun  8 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (3.1.0-0.rc7.1m)
- sync Fedora

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-4m)
- makimodosi 3.0.3-2

* Wed Mar 14 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-3m)
- add export LDFLAGS="-L/%{_lib} $LDFLAGS"
-- Because /lib/libncurses.so cannot be linked

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (3.0.3-2m)
- rebuild against python-2.5

* Mon Oct 06 2006 TABUCHI Takaaki <tab@momonga-linux.org>
- (3.0.3-1m)
- merge FC 3.0.3-1

* Fri Jul  7 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0.2-1m)
- import from fc-devel

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (3.0-0.20051206.1m)
- sync with fc-devel

* Sat Oct 30 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2-20051030m)
- rebuild against python-2.4.2

* Wed Mar 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2-20050308m)
- import from FC

* Wed Mar  9 2005 Rik van Riel <riel@redhat.com> 2-20050308
- upgrade to last night's snapshot
- new compile fix patch

* Sun Mar  6 2005 Rik van Riel <riel@redhat.com> 2-20050305
- the gcc4 compile patches are now upstream
- upgrade to last night's snapshot, drop patches locally

* Fri Mar  4 2005 Rik van Riel <riel@redhat.com> 2-20050303
- finally got everything to compile with gcc4 -Wall -Werror

* Thu Mar  3 2005 Rik van Riel <riel@redhat.com> 2-20050303
- upgrade to last night's Xen-unstable snapshot
- drop printf warnings patch, which is upstream now

* Wed Feb 23 2005 Rik van Riel <riel@redhat.com> 2-20050222
- upgraded to last night's Xen snapshot
- compile warning fixes are now upstream, drop patch

* Sat Feb 19 2005 Rik van Riel <riel@redhat.com> 2-20050219
- fix more compile warnings
- fix the fwrite return check

* Fri Feb 18 2005 Rik van Riel <riel@redhat.com> 2-20050218
- upgrade to last night's Xen snapshot
- a kernel upgrade is needed to run this Xen, the hypervisor
  interface changed slightly
- comment out unused debugging function in plan9 domain builder
  that was giving compile errors with -Werror

* Tue Feb  8 2005 Rik van Riel <riel@redhat.com> 2-20050207
- upgrade to last night's Xen snapshot

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201.1
- move everything to /var/lib/xen

* Tue Feb  1 2005 Rik van Riel <riel@redhat.com> 2-20050201
- upgrade to new upstream Xen snapshot

* Tue Jan 25 2005 Jeremy Katz <katzj@redhat.com>
- add buildreqs on python-devel and xorg-x11-devel (strange AT nsk.no-ip.org)

* Mon Jan 24 2005 Rik van Riel <riel@redhat.com> - 2-20050124
- fix /etc/xen/scripts/network to not break with ipv6 (also sent upstream)

* Fri Jan 14 2005 Jeremy Katz <katzj@redhat.com> - 2-20050114
- update to new snap
- python-twisted is its own package now
- files are in /usr/lib/python now as well, ugh.

* Tue Jan 11 2005 Rik van Riel <riel@redhat.com>
- add segment fixup patch from xen tree
- fix %files list for python-twisted

* Mon Jan 10 2005 Rik van Riel <riel@redhat.com>
- grab newer snapshot, that does start up
- add /var/xen/xend-db/{domain,vnet} to %files section

* Thu Jan  6 2005 Rik van Riel <riel@redhat.com>
- upgrade to new snapshot of xen-unstable

* Mon Dec 13 2004 Rik van Riel <riel@redhat.com>
- build python-twisted as a subpackage
- update to latest upstream Xen snapshot

* Sun Dec  5 2004 Rik van Riel <riel@redhat.com>
- grab new Xen tarball (with wednesday's patch already included)
- transfig is a buildrequire, add it to the spec file

* Wed Dec  1 2004 Rik van Riel <riel@redhat.com>
- fix up Che's spec file a little bit
- create patch to build just Xen, not the kernels

* Wed Dec 01 2004 Che
- initial rpm release
